Given an array nums and a target value k, find the maximum length of a subarray that sums to k. If there isn't one, return 0 instead.
Note:
The sum of the entire nums array is guaranteed to fit within the 32-bit signed integer range.
Example 1:
Given nums = [1, -1, 5, -2, 3], k = 3,
return 4. (because the subarray [1, -1, 5, -2] sums to 3 and is the longest)
Example 2:
Given nums = [-2, -1, 2, 1], k = 1,
return 2. (because the subarray [-1, 2] sums to 1 and is the longest)
Follow Up:
Can you do it in O(n) time?
Solution:Hashmap
思路:累积sum,存入hashmap(sum_value, index),已有的话不更新(为保证最长),并在hashmap中找是否有另一半作差能得到k(subarray和为k)
Time Complexity: O(N) Space Complexity: O(N)
Solution Code:
class Solution {
public int maxSubArrayLen(int[] nums, int k) {
int sum = 0, max = 0;
HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();
map.put(0, -1); // corner case for from 0 .. i sum
for (int i = 0; i < nums.length; i++) {
sum = sum + nums[i];
if (map.containsKey(sum - k)) max = Math.max(max, i - map.get(sum - k));
if (!map.containsKey(sum)) map.put(sum, i);
}
return max;
}
}